Index: squid/src/store_rebuild.c
diff -u squid/src/store_rebuild.c:1.1.1.2 squid/src/store_rebuild.c:1.1.1.2.10.1
--- squid/src/store_rebuild.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/store_rebuild.c	Fri Nov 10 10:44:53 2000
@@ -91,8 +91,10 @@
 static void storeRebuildComplete(void);
 static EVH storeRebuildADirectory;
 static int storeGetNextFile(rebuild_dir *, int *sfileno, int *size);
-static StoreEntry *storeAddDiskRestore(const cache_key * key,
-    int file_number,
+#ifdef MMAPSTORE
+static StoreEntry *storeAddDiskRestore(storeSwapLogData*s);
+#else
+static StoreEntry *storeAddDiskRestore(int file_number,
     size_t swap_file_sz,
     time_t expires,
     time_t timestamp,
@@ -101,6 +103,7 @@
     u_num32 refcount,
     u_short flags,
     int clean);
+#endif
 static AIOCB storeValidateComplete;
 
 static int
@@ -109,7 +112,13 @@
     LOCAL_ARRAY(char, hdr_buf, DISK_PAGE_SIZE);
     StoreEntry *e = NULL;
     StoreEntry tmpe;
+#ifdef MMAPSTORE
+    storeSwapLogData tmps;
+    SwapDir *sd = Config.cacheSwap.swapDirs + d->dirn;
+    cache_key*key;
+#else
     cache_key key[MD5_DIGEST_CHARS];
+#endif
     int sfileno = 0;
     int count;
     int size;
@@ -119,7 +128,7 @@
     tlv *tlv_list;
     tlv *t;
     assert(d != NULL);
-    debug(20, 3) ("storeRebuildFromDirectory: DIR #%d\n", d->dirn);
+    debug(20, 2) ("storeRebuildFromDirectory: DIR #%d\n", d->dirn);
     for (count = 0; count < d->speed; count++) {
 	assert(fd == -1);
 	fd = storeGetNextFile(d, &sfileno, &size);
@@ -169,8 +178,14 @@
 	    continue;
 	}
 	debug(20, 3) ("storeRebuildFromDirectory: successful swap meta unpacking\n");
-	memset(key, '\0', MD5_DIGEST_CHARS);
 	memset(&tmpe, '\0', sizeof(StoreEntry));
+#ifdef MMAPSTORE
+	tmpe.s=&tmps;
+	memset(&tmps, '\0', sizeof(StoreEntry));
+	key = tmps.key;
+#else
+	memset(key, '\0', MD5_DIGEST_CHARS);
+#endif
 	for (t = tlv_list; t; t = t->next) {
 	    switch (t->type) {
 	    case STORE_META_KEY:
@@ -179,7 +194,7 @@
 		break;
 	    case STORE_META_STD:
 		assert(t->length == STORE_HDR_METASIZE);
-		xmemcpy(&tmpe.timestamp, t->value, STORE_HDR_METASIZE);
+		xmemcpy(&tmpe.Stimestamp, t->value, STORE_HDR_METASIZE);
 		break;
 	    default:
 		break;
@@ -192,25 +207,27 @@
 	    storeUnlinkFileno(sfileno);
 	    continue;
 	}
+#ifndef MMAPSTORE
 	tmpe.key = key;
+#endif
 	/* check sizes */
-	if (tmpe.swap_file_sz == 0) {
-	    tmpe.swap_file_sz = sb.st_size;
-	} else if (tmpe.swap_file_sz == sb.st_size - swap_hdr_len) {
-	    tmpe.swap_file_sz = sb.st_size;
-	} else if (tmpe.swap_file_sz != sb.st_size) {
+	if (tmpe.Sswap_file_sz == 0) {
+	    tmpe.Sswap_file_sz = sb.st_size;
+	} else if (tmpe.Sswap_file_sz == sb.st_size - swap_hdr_len) {
+	    tmpe.Sswap_file_sz = sb.st_size;
+	} else if (tmpe.Sswap_file_sz != sb.st_size) {
 	    debug(20, 1) ("storeRebuildFromDirectory: SIZE MISMATCH %d!=%d\n",
-		tmpe.swap_file_sz, (int) sb.st_size);
+		tmpe.Sswap_file_sz, (int) sb.st_size);
 	    storeUnlinkFileno(sfileno);
 	    continue;
 	}
-	if (EBIT_TEST(tmpe.flags, KEY_PRIVATE)) {
+	if (EBIT_TEST(tmpe.Sflag, KEY_PRIVATE)) {
 	    storeUnlinkFileno(sfileno);
 	    RebuildState.badflags++;
 	    continue;
 	}
 	e = storeGet(key);
-	if (e && e->lastref >= tmpe.lastref) {
+	if (e && e->Slastref >= tmpe.Slastref) {
 	    /* key already exists, current entry is newer */
 	    /* keep old, ignore new */
 	    RebuildState.dupcount++;
@@ -218,21 +235,34 @@
 	} else if (NULL != e) {
 	    /* URL already exists, this swapfile not being used */
 	    /* junk old, load new */
-	    storeRelease(e);	/* release old entry */
+	    storeLockObject(e);
+	    storeReleaseRequest(e);	/* release old entry */
+	    e->lock_count--;
 	    RebuildState.dupcount++;
 	}
 	RebuildState.objcount++;
 	storeEntryDump(&tmpe, 5);
+#ifdef MMAPSTORE
+	{
+	    storeSwapLogData *ns = memAllocate(MEM_STORESWAPLOGDATA);
+            *ns = tmps;
+	    ns->swap_file_number = -1;
+	    set_swap_file_number(ns, sfileno);
+	    e = storeAddDiskRestore(storeSwapAppendList(sd, ns));
+	}
+	storeDirSwapLog(e, SWAP_LOG_ADD);
+#else
 	e = storeAddDiskRestore(key,
 	    sfileno,
-	    tmpe.swap_file_sz,
-	    tmpe.expires,
-	    tmpe.timestamp,
-	    tmpe.lastref,
-	    tmpe.lastmod,
-	    tmpe.refcount,	/* refcount */
-	    tmpe.flags,		/* flags */
+	    tmpe.Sswap_file_sz,
+	    tmpe.Sexpires,
+	    tmpe.Stimestamp,
+	    tmpe.Slastref,
+	    tmpe.Slastmod,
+	    tmpe.Srefcount,	/* refcount */
+	    tmpe.Sflag,		/* flags */
 	    d->clean);
+#endif
     }
     return count;
 }
@@ -241,16 +271,28 @@
 storeRebuildFromSwapLog(rebuild_dir * d)
 {
     StoreEntry *e = NULL;
-    storeSwapLogData s;
+    storeSwapLogData ts,*s;
     size_t ss = sizeof(storeSwapLogData);
     int count;
     int used;			/* is swapfile already in use? */
     int disk_entry_newer;	/* is the log entry newer than current entry? */
     double x;
-    assert(d != NULL);
     /* load a number of objects per invocation */
+#ifdef MMAPSTORE
+    SwapDir *sd = Config.cacheSwap.swapDirs + d->dirn;
+    struct mmapinfo *mi = sd->mi;
+    for (s=mi->mmapbase, count = 0;; s++, count++) {
+	if (s - mi->mmapend >= 0) {
+	    debug(20, 1) ("Done reading Cache Dir #%d swaplog (%d entries)\n",
+		d->dirn, d->n_read);
+	    d->log = 0;
+	    return -1;
+	}
+#else
+    assert(d != NULL);
+    s = &ts;
     for (count = 0; count < d->speed; count++) {
-	if (fread(&s, ss, 1, d->log) != 1) {
+	if (fread(s, ss, 1, d->log) != 1) {
 	    debug(20, 1) ("Done reading Cache Dir #%d swaplog (%d entries)\n",
 		d->dirn, d->n_read);
 	    fclose(d->log);
@@ -258,20 +300,28 @@
 	    storeDirCloseTmpSwapLog(d->dirn);
 	    return -1;
 	}
+#endif
 	d->n_read++;
-	if (s.op <= SWAP_LOG_NOP)
+#ifdef MMAPSTORE
+	if (s->swap_file_number<0) {
+	    goto delit;
+	}
+#else
+	if (s->op <= SWAP_LOG_NOP)
 	    continue;
-	if (s.op >= SWAP_LOG_MAX)
+	if (s->op >= SWAP_LOG_MAX)
 	    continue;
-	s.swap_file_number = storeDirProperFileno(d->dirn, s.swap_file_number);
+#endif
+	s->swap_file_number = storeDirProperFileno(d->dirn, s->swap_file_number);
+#ifndef MMAPSTORE
 	debug(20, 3) ("storeRebuildFromSwapLog: %s %s %08X\n",
-	    swap_log_op_str[(int) s.op],
-	    storeKeyText(s.key),
-	    s.swap_file_number);
-	if (s.op == SWAP_LOG_ADD) {
+	    swap_log_op_str[(int) s->op],
+	    storeKeyText(s->key),
+	    s->swap_file_number);
+	if (s->op == SWAP_LOG_ADD) {
 	    (void) 0;
-	} else if (s.op == SWAP_LOG_DEL) {
-	    if ((e = storeGet(s.key)) != NULL) {
+	} else if (s->op == SWAP_LOG_DEL) {
+	    if ((e = storeGet(s->key)) != NULL) {
 		/*
 		 * Make sure we don't unlink the file, it might be
 		 * in use by a subsequent entry.  Also note that
@@ -281,9 +331,9 @@
 		 */
 		storeExpireNow(e);
 		storeReleaseRequest(e);
-		if (e->swap_file_number > -1) {
-		    storeDirMapBitReset(e->swap_file_number);
-		    e->swap_file_number = -1;
+		if (e->Sswap_file_number > -1) {
+		    storeDirMapBitReset(e->Sswap_file_number);
+		    e->Sswap_file_number = -1;
 		}
 		RebuildState.objcount--;
 		RebuildState.cancelcount++;
@@ -297,49 +347,60 @@
 	    RebuildState.invalid++;
 	    continue;
 	}
+#endif
 	if ((++RebuildState.linecount & 0xFFFF) == 0)
 	    debug(20, 1) ("  %7d Entries read so far.\n",
 		RebuildState.linecount);
-	if (!storeDirValidFileno(s.swap_file_number)) {
+	if (!storeDirValidFileno(s->swap_file_number)) {
 	    RebuildState.invalid++;
-	    continue;
+	    goto remswap;
 	}
-	if (EBIT_TEST(s.flags, KEY_PRIVATE)) {
+	used = storeDirMapBitTest(s->swap_file_number);
+	if (EBIT_TEST(s->flags, KEY_PRIVATE)) {
 	    RebuildState.badflags++;
-	    continue;
+	    if (!used)
+	       goto remswap;
+	    goto delit;
 	}
-	e = storeGet(s.key);
-	used = storeDirMapBitTest(s.swap_file_number);
+	e = storeGet(s->key);
 	/* If this URL already exists in the cache, does the swap log
 	 * appear to have a newer entry?  Compare 'lastref' from the
-	 * swap log to e->lastref. */
-	disk_entry_newer = e ? (s.lastref > e->lastref ? 1 : 0) : 0;
+	 * swap log to e->Slastref. */
+	disk_entry_newer = e ? (s->lastref > e->Slastref ? 1 : 0) : 0;
 	if (used && !disk_entry_newer) {
 	    /* log entry is old, ignore it */
 	    RebuildState.clashcount++;
-	    continue;
-	} else if (used && e && e->swap_file_number == s.swap_file_number) {
+	    goto delit;
+	} else if (used && e && e->Sswap_file_number == s->swap_file_number) {
 	    /* swapfile taken, same URL, newer, update meta */
 	    if (e->store_status == STORE_OK) {
-		e->lastref = s.timestamp;
-		e->timestamp = s.timestamp;
-		e->expires = s.expires;
-		e->lastmod = s.lastmod;
-		e->flags = s.flags;
-		e->refcount += s.refcount;
+		e->Slastref = s->timestamp;
+		e->Stimestamp = s->timestamp;
+		e->Sexpires = s->expires;
+		e->Slastmod = s->lastmod;
+		e->Sflag = s->flags;
+		e->Srefcount += s->refcount;
+#ifdef	HPL_REPL
+		/* Update the position of this object in the store and memory heaps. */
+		assert(e->n.ode.id >= 0);
+		heap_update(sd->heap, &e->n.ode);
+		if (e->mem_obj)
+		  heap_update(inmem_heap, &e->mem_obj->n.ode);
+#endif	/* HPL_REPL */
+
 	    } else {
 		debug_trap("storeRebuildFromSwapLog: bad condition");
 		debug(20, 1) ("\tSee %s:%d\n", __FILE__, __LINE__);
 	    }
-	    continue;
+	    goto delit;
 	} else if (used) {
 	    /* swapfile in use, not by this URL, log entry is newer */
 	    /* This is sorta bad: the log entry should NOT be newer at this
 	     * point.  If the log is dirty, the filesize check should have
-	     * caught this.  If the log is clean, there should never be a
+	     * caught this->  If the log is clean, there should never be a
 	     * newer entry. */
 	    debug(20, 1) ("WARNING: newer swaplog entry for fileno %08X\n",
-		s.swap_file_number);
+		s->swap_file_number);
 	    /* I'm tempted to remove the swapfile here just to be safe,
 	     * but there is a bad race condition in the NOVM version if
 	     * the swapfile has recently been opened for writing, but
@@ -349,24 +410,32 @@
 	    /* We'll assume the existing entry is valid, probably because
 	     * were in a slow rebuild and the the swap file number got taken
 	     * and the validation procedure hasn't run. */
+#ifndef MMAPSTORE
 	    assert(RebuildState.need_to_validate);
+#endif
 	    RebuildState.clashcount++;
-	    continue;
+	    goto delit;
 	} else if (e && !disk_entry_newer) {
 	    /* key already exists, current entry is newer */
 	    /* keep old, ignore new */
 	    RebuildState.dupcount++;
+remswap:
+#ifdef MMAPSTORE
+	    storeUnlinkFileno(s->swap_file_number);
+erasit:	    storeDirMapBitReset(s->swap_file_number);
+delit:	    storeSwapToFreeList(sd, s);
+#else
+delit:;
+#endif
 	    continue;
 	} else if (e) {
 	    /* key already exists, this swapfile not being used */
 	    /* junk old, load new */
 	    storeExpireNow(e);
 	    storeReleaseRequest(e);
-	    if (e->swap_file_number > -1) {
-		storeDirMapBitReset(e->swap_file_number);
-		e->swap_file_number = -1;
-	    }
 	    RebuildState.dupcount++;
+	    if (e->Sswap_file_number > -1)
+		goto erasit;
 	} else {
 	    /* URL doesnt exist, swapfile not in use */
 	    /* load new */
@@ -374,17 +443,24 @@
 	}
 	/* update store_swap_size */
 	RebuildState.objcount++;
-	e = storeAddDiskRestore(s.key,
-	    s.swap_file_number,
-	    s.swap_file_sz,
-	    s.expires,
-	    s.timestamp,
-	    s.lastref,
-	    s.lastmod,
-	    s.refcount,
-	    s.flags,
+#ifdef MMAPSTORE
+	e = storeAddDiskRestore(s);
+#else
+	e = storeAddDiskRestore(s->key,
+	    s->swap_file_number,
+	    s->swap_file_sz,
+	    s->expires,
+	    s->timestamp,
+	    s->lastref,
+	    s->lastmod,
+	    s->refcount,
+	    s->flags,
 	    d->clean);
 	storeDirSwapLog(e, SWAP_LOG_ADD);
+#endif
+#if HPL_REPL
+	heap_insert(sd->heap, e);
+#endif
     }
     return count;
 }
@@ -395,6 +471,7 @@
     int count;
     rebuild_dir *d;
     rebuild_dir **D;
+loop:
     if ((d = RebuildState.rebuild_dir) == NULL) {
 	storeRebuildComplete();
 	return;
@@ -409,7 +486,7 @@
 	d->next = NULL;
     }
     if (opt_foreground_rebuild)
-	storeRebuildADirectory(NULL);
+	goto loop;
     else
 	eventAdd("storeRebuild", storeRebuildADirectory, NULL, 0.0, 1);
 }
@@ -435,7 +512,7 @@
     tlv *tlv_list;
     StoreEntry e;
     e.key = key;
-    e.swap_file_sz = swap_file_sz;
+    e.Sswap_file_sz = swap_file_sz;
     e.expires = expires;
     e.lastref = lastref;
     e.refcount = refcount;
@@ -543,6 +620,9 @@
 /* Add a new object to the cache with empty memory copy and pointer to disk
  * use to rebuild store from disk. */
 static StoreEntry *
+#ifdef MMAPSTORE
+storeAddDiskRestore(storeSwapLogData*s)
+#else
 storeAddDiskRestore(const cache_key * key,
     int file_number,
     size_t swap_file_sz,
@@ -553,32 +633,39 @@
     u_num32 refcount,
     u_short flags,
     int clean)
+#endif
 {
     StoreEntry *e = NULL;
+#ifndef MMAPSTORE
     debug(20, 5) ("StoreAddDiskRestore: %s, fileno=%08X\n", storeKeyText(key), file_number);
+#endif
     /* if you call this you'd better be sure file_number is not 
      * already in use! */
     e = new_StoreEntry(STORE_ENTRY_WITHOUT_MEMOBJ, NULL, NULL);
     e->store_status = STORE_OK;
     storeSetMemStatus(e, NOT_IN_MEMORY);
     e->swap_status = SWAPOUT_DONE;
-    e->swap_file_number = file_number;
-    e->swap_file_sz = swap_file_sz;
     e->lock_count = 0;
-    e->refcount = 0;
-    e->lastref = lastref;
-    e->timestamp = timestamp;
-    e->expires = expires;
-    e->lastmod = lastmod;
-    e->refcount = refcount;
-    e->flags = flags;
-    EBIT_SET(e->flags, ENTRY_CACHABLE);
-    EBIT_CLR(e->flags, RELEASE_REQUEST);
-    EBIT_CLR(e->flags, KEY_PRIVATE);
     e->ping_status = PING_NONE;
-    EBIT_CLR(e->flags, ENTRY_VALIDATED);
-    storeDirMapBitSet(e->swap_file_number);
-    storeHashInsert(e, key);	/* do it after we clear KEY_PRIVATE */
+#ifdef MMAPSTORE
+    e->s = s;
+#else
+    e->key = key;
+    e->Sswap_file_number = file_number;
+    e->Sswap_file_sz = swap_file_sz;
+    e->Slastref = lastref;
+    e->Stimestamp = timestamp;
+    e->Sexpires = expires;
+    e->Slastmod = lastmod;
+    e->Srefcount = refcount;
+    e->Sflag = flags;
+#endif
+    EBIT_SET(e->Sflag, ENTRY_CACHABLE);
+    EBIT_CLR(e->Sflag, RELEASE_REQUEST);
+    EBIT_CLR(e->Sflag, KEY_PRIVATE);
+    EBIT_CLR(e->Sflag, ENTRY_VALIDATED);
+    storeDirMapBitSet(e->Sswap_file_number);
+    storeHashInsert(e, e->Skey);	/* do it after we clear KEY_PRIVATE */
     return e;
 }
 
@@ -591,13 +678,18 @@
     StoreEntry *e;
     hash_link *link_ptr = NULL;
     hash_link *link_next = NULL;
+    time_t force_doublecheck = RebuildState.start - 1024;
     if (++bucketnum >= store_hash_buckets) {
 	debug(20, 1) ("  Completed Validation Procedure\n");
 	debug(20, 1) ("  Validated %d Entries\n", validnum);
 	debug(20, 1) ("  store_swap_size = %dk\n", store_swap_size);
 	store_rebuilding = 0;
-	if (opt_store_doublecheck)
+	if (opt_store_doublecheck) {
+#if 0	/* bogus assertion srb */
 	    assert(store_errors == 0);
+#endif
+	    opt_store_doublecheck = 0;	/* only do this once */
+	}
 	if (store_digest)
 	    storeDigestNoteStoreReady();
 	return;
@@ -606,41 +698,57 @@
     while (NULL != (link_ptr = link_next)) {
 	link_next = link_ptr->next;
 	e = (StoreEntry *) link_ptr;
-	if (EBIT_TEST(e->flags, ENTRY_VALIDATED))
+	if (EBIT_TEST(e->Sflag, ENTRY_VALIDATED))
 	    continue;
+	if (e->Sswap_file_number < 0)
+	    continue;
+	if (EBIT_TEST(e->Sflag, RELEASE_REQUEST)) {
 	/*
 	 * Calling storeRelease() has no effect because we're
 	 * still in 'store_rebuilding' state
 	 */
-	if (e->swap_file_number < 0)
+relit:	    storeLockObject(e);
+	    storeReleaseRequest(e);	/* release entry */
+	    e->lock_count--;
 	    continue;
-	if (opt_store_doublecheck) {
+	}
+  	if (e->Sswap_file_number < 0)
+  	    continue;
+	if (opt_store_doublecheck ||
+		!e->Sswap_file_sz ||
+		e->Slastref > force_doublecheck) {
 	    struct stat sb;
-	    if (stat(storeSwapFullPath(e->swap_file_number, NULL), &sb) < 0) {
+	    if (stat(storeSwapFullPath(e->Sswap_file_number, NULL), &sb) < 0) {
+	        static unsigned vleft = 1024;
 		store_errors++;
-		debug(20, 0) ("storeCleanup: MISSING SWAP FILE\n");
-		debug(20, 0) ("storeCleanup: FILENO %08X\n", e->swap_file_number);
-		debug(20, 0) ("storeCleanup: PATH %s\n",
-		    storeSwapFullPath(e->swap_file_number, NULL));
-		storeEntryDump(e, 0);
-		continue;
+	        if (vleft) {
+		    if (!--vleft)
+			debug (20, 0) ("storeCleanup: Too many missing "
+			    "swapfiles, suppressing logging\n");
+		    debug(20, 1) ("storeCleanup: MISSING SWAP FILE\n");
+		    debug(20, 1) ("storeCleanup: FILENO %08X\n",
+			e->Sswap_file_number);
+		    debug(20, 1) ("storeCleanup: PATH %s\n",
+		        storeSwapFullPath(e->Sswap_file_number, NULL));
+dumpit:		    storeEntryDump(e, 1);
+	    }
+		goto relit;
 	    }
-	    if (e->swap_file_sz != sb.st_size) {
+	    if (e->Sswap_file_sz != sb.st_size) {
 		store_errors++;
-		debug(20, 0) ("storeCleanup: SIZE MISMATCH\n");
-		debug(20, 0) ("storeCleanup: FILENO %08X\n", e->swap_file_number);
-		debug(20, 0) ("storeCleanup: PATH %s\n",
-		    storeSwapFullPath(e->swap_file_number, NULL));
-		debug(20, 0) ("storeCleanup: ENTRY SIZE: %d, FILE SIZE: %d\n",
-		    e->swap_file_sz, (int) sb.st_size);
-		storeEntryDump(e, 0);
-		continue;
+		debug(20, 1) ("storeCleanup: SIZE MISMATCH\n");
+		debug(20, 1) ("storeCleanup: FILENO %08X\n", e->Sswap_file_number);
+		debug(20, 1) ("storeCleanup: PATH %s\n",
+		    storeSwapFullPath(e->Sswap_file_number, NULL));
+		debug(20, 1) ("storeCleanup: ENTRY SIZE: %d, FILE SIZE: %d\n",
+		    e->Sswap_file_sz, (int) sb.st_size);
+		goto dumpit;
 	    }
 	}
-	EBIT_SET(e->flags, ENTRY_VALIDATED);
+	EBIT_SET(e->Sflag, ENTRY_VALIDATED);
 	/* Only set the file bit if we know its a valid entry */
 	/* otherwise, set it in the validation procedure */
-	storeDirUpdateSwapSize(e->swap_file_number, e->swap_file_sz, 1);
+	storeDirUpdateSwapSize(e->Sswap_file_number, e->Sswap_file_sz, 1);
 	if ((++validnum & 0xFFFF) == 0)
 	    debug(20, 1) ("  %7d Entries Validated so far.\n", validnum);
     }
@@ -656,13 +764,13 @@
 #if !USE_ASYNC_IO
     int x;
 #endif
-    assert(!EBIT_TEST(e->flags, ENTRY_VALIDATED));
-    if (e->swap_file_number < 0) {
-	EBIT_CLR(e->flags, ENTRY_VALIDATED);
+    assert(!EBIT_TEST(e->Sflag, ENTRY_VALIDATED));
+    if (e->Sswap_file_number < 0) {
+	EBIT_CLR(e->Sflag, ENTRY_VALIDATED);
 	callback(callback_data, 0, 0);
 	return;
     }
-    path = storeSwapFullPath(e->swap_file_number, NULL);
+    path = storeSwapFullPath(e->Sswap_file_number, NULL);
     sb = xmalloc(sizeof(struct stat));
     ctrlp = xmalloc(sizeof(valid_ctrl_t));
     ctrlp->sb = sb;
@@ -698,14 +806,14 @@
 	return;
     }
     if (retcode < 0 && errcode == EWOULDBLOCK) {
-	path = storeSwapFullPath(e->swap_file_number, NULL);
+	path = storeSwapFullPath(e->Sswap_file_number, NULL);
 	retcode = stat(path, sb);
     }
-    if (retcode < 0 || sb->st_size == 0 || sb->st_size != e->swap_file_sz) {
-	EBIT_CLR(e->flags, ENTRY_VALIDATED);
+    if (retcode < 0 || sb->st_size == 0 || sb->st_size != e->Sswap_file_sz) {
+	EBIT_CLR(e->Sflag, ENTRY_VALIDATED);
     } else {
-	EBIT_SET(e->flags, ENTRY_VALIDATED);
-	storeDirUpdateSwapSize(e->swap_file_number, e->swap_file_sz, 1);
+	EBIT_SET(e->Sflag, ENTRY_VALIDATED);
+	storeDirUpdateSwapSize(e->Sswap_file_number, e->Sswap_file_sz, 1);
     }
     errno = errcode;
     ctrlp->callback(ctrlp->callback_data, retcode, errcode);
@@ -750,6 +858,7 @@
     int i;
     memset(&RebuildState, '\0', sizeof(RebuildState));
     RebuildState.start = squid_curtime;
+    store_swap_size = 0;
     for (i = 0; i < Config.cacheSwap.n_configured; i++) {
 	d = xcalloc(1, sizeof(rebuild_dir));
 	d->dirn = i;
Index: squid/src/store_swapin.c
diff -u squid/src/store_swapin.c:1.1.1.2 squid/src/store_swapin.c:1.1.1.2.12.1
--- squid/src/store_swapin.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/store_swapin.c	Fri Nov 10 10:44:53 2000
@@ -50,21 +50,21 @@
 {
     swapin_ctrl_t *ctrlp;
     assert(e->mem_status == NOT_IN_MEMORY);
-    if (!EBIT_TEST(e->flags, ENTRY_VALIDATED)) {
+    if (!EBIT_TEST(e->Sflag, ENTRY_VALIDATED)) {
 	/* We're still reloading and haven't validated this entry yet */
 	callback(-1, callback_data);
 	return;
     }
     debug(20, 3) ("storeSwapInStart: called for %08X %s \n",
-	e->swap_file_number, storeKeyText(e->key));
+	e->Sswap_file_number, storeKeyText(e->Skey));
     assert(e->swap_status == SWAPOUT_WRITING || e->swap_status == SWAPOUT_DONE);
-    assert(e->swap_file_number >= 0);
+    assert(e->Sswap_file_number >= 0);
     assert(e->mem_obj != NULL);
     ctrlp = xmalloc(sizeof(swapin_ctrl_t));
     ctrlp->e = e;
     ctrlp->callback = callback;
     ctrlp->callback_data = callback_data;
-    if (EBIT_TEST(e->flags, ENTRY_VALIDATED))
+    if (EBIT_TEST(e->Sflag, ENTRY_VALIDATED))
 	storeSwapInValidateComplete(ctrlp, 0, 0);
     else
 	storeValidate(e, storeSwapInValidateComplete, ctrlp, callback_data);
@@ -81,13 +81,13 @@
     }
     e = ctrlp->e;
     assert(e->mem_status == NOT_IN_MEMORY);
-    if (!EBIT_TEST(e->flags, ENTRY_VALIDATED)) {
+    if (!EBIT_TEST(e->Sflag, ENTRY_VALIDATED)) {
 	/* Invoke a store abort that should free the memory object */
 	(ctrlp->callback) (-1, ctrlp->callback_data);
 	xfree(ctrlp);
 	return;
     }
-    ctrlp->path = xstrdup(storeSwapFullPath(e->swap_file_number, NULL));
+    ctrlp->path = xstrdup(storeSwapFullPath(e->Sswap_file_number, NULL));
     debug(20, 3) ("storeSwapInValidateComplete: Opening %s\n", ctrlp->path);
     store_open_disk_fd++;
     file_open(ctrlp->path,
@@ -126,8 +126,8 @@
 	file_close(fd);
 	store_open_disk_fd--;
 	fd = -1;
-    } else if (sb.st_size == 0 || sb.st_size != e->swap_file_sz) {
-	debug(20, 1) ("storeSwapInFileOpened: %s: Size mismatch: %d(fstat) != %d(object)\n", ctrlp->path, (int) sb.st_size, e->swap_file_sz);
+    } else if (sb.st_size == 0 || sb.st_size != e->Sswap_file_sz) {
+	debug(20, 1) ("storeSwapInFileOpened: %s: Size mismatch: %d(fstat) != %d(object)\n", ctrlp->path, (int) sb.st_size, e->Sswap_file_sz);
 	file_close(fd);
 	store_open_disk_fd--;
 	fd = -1;
Index: squid/src/store_swapmeta.c
diff -u squid/src/store_swapmeta.c:1.1.1.1 squid/src/store_swapmeta.c:1.1.1.1.12.1
--- squid/src/store_swapmeta.c:1.1.1.1	Tue Jan 25 19:21:47 2000
+++ squid/src/store_swapmeta.c	Fri Nov 10 10:44:53 2000
@@ -72,8 +72,8 @@
     assert(e->swap_status == SWAPOUT_WRITING);
     url = storeUrl(e);
     debug(20, 3) ("storeSwapMetaBuild: %s\n", url);
-    T = storeSwapTLVAdd(STORE_META_KEY, e->key, MD5_DIGEST_CHARS, T);
-    T = storeSwapTLVAdd(STORE_META_STD, &e->timestamp, STORE_HDR_METASIZE, T);
+    T = storeSwapTLVAdd(STORE_META_KEY, e->Skey, MD5_DIGEST_CHARS, T);
+    T = storeSwapTLVAdd(STORE_META_STD, &e->Stimestamp, STORE_HDR_METASIZE, T);
     T = storeSwapTLVAdd(STORE_META_URL, url, strlen(url) + 1, T);
     return TLV;
 }
Index: squid/src/store_swapout.c
diff -u squid/src/store_swapout.c:1.1.1.2 squid/src/store_swapout.c:1.1.1.2.12.1
--- squid/src/store_swapout.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/store_swapout.c	Fri Nov 10 10:44:53 2000
@@ -54,8 +54,8 @@
     assert(e->mem_obj);
     cbdataAdd(ctrlp, cbdataXfree, 0);
     storeLockObject(e);
-    e->swap_file_number = storeDirMapAllocate();
-    ctrlp->swapfilename = xstrdup(storeSwapFullPath(e->swap_file_number, NULL));
+    set_swap_file_number(e, storeDirMapAllocate());
+    ctrlp->swapfilename = xstrdup(storeSwapFullPath(e->Sswap_file_number, NULL));
     ctrlp->e = e;
     ctrlp->oldswapstatus = e->swap_status;
     e->swap_status = SWAPOUT_OPENING;
@@ -74,20 +74,20 @@
     swapout_ctrl_t *ctrlp = data;
     StoreEntry *e = ctrlp->e;
     MemObject *mem = e->mem_obj;
-    debug(20, 3) ("storeSwapOutHandle: '%s', len=%d\n", storeKeyText(e->key), (int) len);
+    debug(20, 3) ("storeSwapOutHandle: '%s', len=%d\n", storeKeyText(e->Skey), (int) len);
     if (flag < 0) {
 	debug(20, 1) ("storeSwapOutHandle: SwapOut failure (err code = %d).\n",
 	    flag);
 	e->swap_status = SWAPOUT_NONE;
-	if (e->swap_file_number > -1) {
-	    storeUnlinkFileno(e->swap_file_number);
-	    storeDirMapBitReset(e->swap_file_number);
+	if (e->Sswap_file_number > -1) {
+	    storeUnlinkFileno(e->Sswap_file_number);
+	    storeDirMapBitReset(e->Sswap_file_number);
 	    if (flag == DISK_NO_SPACE_LEFT) {
-		storeDirDiskFull(e->swap_file_number);
+		storeDirDiskFull(e->Sswap_file_number);
 		storeDirConfigure();
 		storeConfigure();
 	    }
-	    e->swap_file_number = -1;
+	    set_swap_file_number(e, -1);
 	}
 	storeReleaseRequest(e);
 	storeSwapOutFileClose(e);
@@ -112,10 +112,17 @@
     }
     /* swapping complete */
     debug(20, 5) ("storeSwapOutHandle: SwapOut complete: '%s' to %s.\n",
-	storeUrl(e), storeSwapFullPath(e->swap_file_number, NULL));
-    e->swap_file_sz = objectLen(e) + mem->swap_hdr_sz;
+	storeUrl(e), storeSwapFullPath(e->Sswap_file_number, NULL));
+    e->Sswap_file_sz = objectLen(e) + mem->swap_hdr_sz;
+#ifdef	HPL_REPL
+    /* Update the position of this object in the store and memory heaps. */
+    if (e->n.ode.id >= 0)
+        heap_update(Store_Heap(e), &e->n.ode);
+    if (mem->n.ode.id >= 0)
+        heap_update(inmem_heap, &mem->n.ode);
+#endif	/* HPL_REPL */
     e->swap_status = SWAPOUT_DONE;
-    storeDirUpdateSwapSize(e->swap_file_number, e->swap_file_sz, 1);
+    storeDirUpdateSwapSize(e->Sswap_file_number, e->Sswap_file_sz, 1);
     if (storeCheckCachable(e)) {
 	storeLog(STORE_LOG_SWAPOUT, e);
 	storeDirSwapLog(e, SWAP_LOG_ADD);
@@ -142,8 +149,8 @@
     debug(20, 7) ("storeCheckSwapOut: %s\n", storeUrl(e));
     debug(20, 7) ("storeCheckSwapOut: store_status = %s\n",
 	storeStatusStr[e->store_status]);
-    if (EBIT_TEST(e->flags, ENTRY_ABORTED)) {
-	assert(EBIT_TEST(e->flags, RELEASE_REQUEST));
+    if (EBIT_TEST(e->Sflag, ENTRY_ABORTED)) {
+	assert(EBIT_TEST(e->Sflag, RELEASE_REQUEST));
 	storeSwapOutFileClose(e);
 	return;
     }
@@ -158,7 +165,7 @@
 #if USE_ASYNC_IO
     if (mem->inmem_hi < mem->swapout.queue_offset) {
 	storeAbort(e);
-	assert(EBIT_TEST(e->flags, RELEASE_REQUEST));
+	assert(EBIT_TEST(e->Sflag, RELEASE_REQUEST));
 	storeSwapOutFileClose(e);
 	return;
     }
@@ -191,10 +198,10 @@
     if (swapout_size == 0) {
 	if (e->store_status == STORE_OK && !storeSwapOutWriteQueued(mem)) {
 	    debug(20, 7) ("storeCheckSwapOut: nothing to write for STORE_OK\n");
-	    if (e->swap_file_number > -1) {
-		storeUnlinkFileno(e->swap_file_number);
-		storeDirMapBitReset(e->swap_file_number);
-		e->swap_file_number = -1;
+	    if (e->Sswap_file_number > -1) {
+		storeUnlinkFileno(e->Sswap_file_number);
+		storeDirMapBitReset(e->Sswap_file_number);
+	        set_swap_file_number(e, -1);
 	    }
 	    e->swap_status = SWAPOUT_NONE;
 	    storeReleaseRequest(e);
@@ -234,11 +241,12 @@
 	swap_buf,
 	swapout_size);
     if (swap_buf_len < 0) {
-	debug(20, 1) ("stmemCopy returned %d for '%s'\n", swap_buf_len, storeKeyText(e->key));
-	storeUnlinkFileno(e->swap_file_number);
-	storeDirMapBitReset(e->swap_file_number);
-	e->swap_file_number = -1;
+	debug(20, 1) ("stmemCopy returned %d for '%s'\n", swap_buf_len, storeKeyText(e->Skey));
+	storeUnlinkFileno(e->Sswap_file_number);
+	storeDirMapBitReset(e->Sswap_file_number);
 	e->swap_status = SWAPOUT_NONE;
+	storeDirSwapLog(e, SWAP_LOG_DEL);
+	set_swap_file_number(e, -1);
 	memFree(swap_buf, MEM_DISK_BUF);
 	storeReleaseRequest(e);
 	storeSwapOutFileClose(e);
@@ -264,7 +272,7 @@
     MemObject *mem = e->mem_obj;
     swapout_ctrl_t *ctrlp;
     assert(mem != NULL);
-    debug(20, 3) ("storeSwapOutFileClose: %s\n", storeKeyText(e->key));
+    debug(20, 3) ("storeSwapOutFileClose: %s\n", storeKeyText(e->Skey));
     if (mem->swapout.fd < 0) {
 #if USE_ASYNC_IO
 	aioCancel(-1, e);	/* Make doubly certain pending ops are gone */
@@ -306,8 +314,8 @@
 	 * we don't try re-using it over and over
 	 */
 	if (errno != EPERM)
-	    storeDirMapBitReset(e->swap_file_number);
-	e->swap_file_number = -1;
+	    storeDirMapBitReset(e->Sswap_file_number);
+	set_swap_file_number(e, -1);
 	e->swap_status = ctrlp->oldswapstatus;
 	xfree(ctrlp->swapfilename);
 	cbdataFree(ctrlp);
@@ -319,7 +327,7 @@
     e->swap_status = SWAPOUT_WRITING;
     debug(20, 5) ("storeSwapOutFileOpened: Begin SwapOut '%s' to FD %d '%s'\n",
 	storeUrl(e), fd, ctrlp->swapfilename);
-    debug(20, 5) ("swap_file_number=%08X\n", e->swap_file_number);
+    debug(20, 5) ("swap_file_number=%08X\n", e->Sswap_file_number);
     tlv_list = storeSwapMetaBuild(e);
     buf = storeSwapMetaPack(tlv_list, &swap_hdr_sz);
     storeSwapTLVFree(tlv_list);
@@ -399,5 +407,5 @@
     for (sc = e->mem_obj->clients; sc; sc = sc->next)
 	if (sc->type == STORE_DISK_CLIENT)
 	    return 1;
-    return EBIT_TEST(e->flags, ENTRY_CACHABLE);
+    return EBIT_TEST(e->Sflag, ENTRY_CACHABLE);
 }
